# -*- coding: utf-8 -*-

from zope import schema
from zope.interface import Interface
from zope.configuration import fields as configuration_fields


class IStructuredRendererDirective(Interface):

    target = configuration_fields.GlobalInterface(
        title=u"Content type type interface",
        description=u"Should correspond to the interface of the content type.",
        required=True)

    filtering = schema.TextLine(
        title=u"Content types interfaces filtering",
        description=u"Should correspond to the dotted name of an interface.",
        required=False)

    name = schema.TextLine(
        title=u"Name",
        description=u"The name of the renderer",
        required=False)

    description = schema.TextLine(
        title=u"Description",
        description=u"The detailed name of the renderer",
        required=False)
    
    renderer = configuration_fields.GlobalObject(
        title=u"The class used to render the item.",
        description=u"A class.",
        required=False)

    template = configuration_fields.Path(
        title=u"The name of a template.",
        description=u"The template used to display the renderer.",
        required=False
        )
