"""This package adds extensions to portal_catalog.
"""
from Acquisition import aq_inner
from Products.ATContentTypes.interface.image import IImageContent
from Products.ATContentTypes.interface.image import IPhotoAlbumAble
from zope.interface import providedBy


def hasImageAndCaption(object, portal, **kw):
    """This indexable attribute is made to avoid the awakening of the
    object while needing to know if the supposedly attached image exists
    or not. It's very useful for the summary views or other kind of listings.
    """
    if (not IImageContent.providedBy(object) and
        not IPhotoAlbumAble.providedBy(object)):
        return None
    
    if object.getImage():
        caption = getattr(aq_inner(object), "getImageCaption", None)
        return {'image': True,
                'caption': caption and caption() or None}
    else:
        return {'image': False, 'caption': None}


